/*!
 * MediaElement.js
 * http://www.mediaelementjs.com/
 *
 * Wrapper that mimics native HTML5 MediaElement (audio and video)
 * using a variety of technologies (pure JavaScript, Flash, iframe)
 *
 * Copyright 2010-2017, John Dyer (http://j.hn/)
 * License: MIT
 *
 */
!function t(e,a,i){function n(s,o){if(!a[s]){if(!e[s]){var d="function"==typeof require&&require;if(!o&&d)return d(s,!0);if(r)return r(s,!0);var l=new Error("Cannot find module '"+s+"'");throw l.code="MODULE_NOT_FOUND",l}var g=a[s]={exports:{}};e[s][0].call(g.exports,function(t){var a=e[s][1][t];return n(a||t)},g,g.exports,t,e,a,i)}return a[s].exports}for(var r="function"==typeof require&&require,s=0;s<i.length;s++)n(i[s]);return n}({1:[function(t,e,a){"use strict";Object.assign(mejs.MepDefaults,{vastAdTagUrl:"",vastAdsType:"vast"}),Object.assign(MediaElementPlayer.prototype,{vastAdTagIsLoading:!1,vastAdTagIsLoaded:!1,vastStartedPlaying:!1,vastAdTags:[],buildvast:function(t,e,a,i){var n=this;n.isVideo&&(""!==n.options.vastAdTagUrl&&n.vastLoadAdTagInfo(),n.buildads(t,e,a,i),n.vastSetupEvents())},vastSetupEvents:function(){var t=this,e=!1,a=!1,i=!1;t.container.addEventListener("mejsprerollinitialized",function(){if(t.vastAdTags.length>0){var e=t.vastAdTags[0];if(e.trackingEvents.initialization)for(var a=0,i=e.trackingEvents.initialization.length;a<i;a++)t.adsLoadUrl(e.trackingEvents.initialization[a])}}),t.container.addEventListener("mejsprerollstarted",function(){if(t.vastAdTags.length>0){var e=t.vastAdTags[0];if(e.trackingEvents.start)for(var a=0,i=e.trackingEvents.start.length;a<i;a++)t.adsLoadUrl(e.trackingEvents.start[a]);if(!e.shown&&e.impressions.length>0)for(var n=0,r=e.impressions.length;n<r;n++)t.adsLoadUrl(e.impressions[n]);e.shown=!0}}),t.container.addEventListener("mejsprerollvolumechanged",function(){if(t.vastAdTags.length>0&&t.options.indexPreroll<t.vastAdTags.length){var e=t.vastAdTags[t.options.indexPreroll];if(e.trackingEvents.mute&&!t.media.volume)for(var a=0,i=e.trackingEvents.mute.length;a<i;a++)t.adsLoadUrl(e.trackingEvents.mute[a]);if(e.trackingEvents.unmute&&t.media.volume)for(var n=0,r=e.trackingEvents.unmute.length;n<r;n++)t.adsLoadUrl(e.trackingEvents.unmute[n])}}),t.container.addEventListener("mejsprerolltimeupdate",function(n){if(t.vastAdTags.length>0&&t.options.indexPreroll<t.vastAdTags.length){var r=n.detail.duration,s=n.detail.currentTime,o=100*Math.min(1,Math.max(0,s/r)),d=t.vastAdTags[t.options.indexPreroll],l=o>=25&&o<50,g=o>=50&&o<75,v=o>=75&&o<100;if(d.trackingEvents.firstQuartile&&!e&&l){for(var c=0,m=d.trackingEvents.firstQuartile.length;c<m;c++)t.adsLoadUrl(d.trackingEvents.firstQuartile[c]);e=!0}else if(d.trackingEvents.midpoint&&!a&&g){for(var p=0,u=d.trackingEvents.midpoint.length;p<u;p++)t.adsLoadUrl(d.trackingEvents.midpoint[p]);a=!0}else if(d.trackingEvents.thirdQuartile&&!i&&v){for(var h=0,f=d.trackingEvents.thirdQuartile.length;h<f;h++)t.adsLoadUrl(d.trackingEvents.thirdQuartile[h]);i=!0}}}),t.container.addEventListener("mejsprerollended",function(){var n=t.vastAdTags[t.options.indexPreroll];if(t.vastAdTags.length>0&&t.options.indexPreroll<t.vastAdTags.length&&n.trackingEvents.complete)for(var r=0,s=n.trackingEvents.complete.length;r<s;r++)t.adsLoadUrl(n.trackingEvents.complete[r]);e=!1,a=!1,i=!1}),t.container.addEventListener("mejsprerolladsclicked",function(){var e=t.vastAdTags[t.options.indexPreroll];t.vastAdTags.length>0&&t.options.indexPreroll<t.vastAdTags.length&&e.clickThrough&&e.clickTracking&&t.adsLoadUrl(e.clickTracking)}),t.container.addEventListener("mejsprerollskipclicked",function(){var e=t.vastAdTags[t.options.indexPreroll];if(t.vastAdTags.length>0&&t.options.indexPreroll<t.vastAdTags.length&&e.trackingEvents.skip)for(var a=0,i=e.trackingEvents.skip.length;a<i;a++)t.adsLoadUrl(e.trackingEvents.skip[a])})},vastSetAdTagUrl:function(t){var e=this;e.options.vastAdTagUrl=t,e.options.indexPreroll=0,e.vastAdTagIsLoaded=!1,e.vastAdTags=[]},vastLoadAdTagInfo:function(){var t=this;t.adsDataIsLoading=!0,t.vastAdTagIsLoading=!0,t.loadAdTagInfoDirect()},loadAdTagInfoDirect:function(){var t=this;mejs.Utils.ajax(t.options.vastAdTagUrl,"xml",function(e){"vpaid"===t.options.vastAdsType?t.vpaidParseVpaidData(e):t.vastParseVastData(e)},function(e){console.error("vast3:direct:error",e),t.loadAdTagInfoProxy()})},loadAdTagInfoProxy:function(){var t=this,e=location.protocol,a='select * from xml where url="'+encodeURI(t.options.vastAdTagUrl)+'"',i="http"+(/^https/.test(e)?"s":"")+"://query.yahooapis.com/v1/public/yql?format=xml&q="+a;mejs.Utils.ajax(i,"xml",function(e){"vpaid"===t.options.vastAdsType?t.vpaidParseVpaidData(e):t.vastParseVastData(e)},function(t){console.error("vast:proxy:yahoo:error",t)})},vastParseVastData:function(t){var e=this,a=t.getElementsByTagName("Ad");if(a.length){e.vastAdTags=[],e.options.indexPreroll=0;for(var i=0,n=a.length;i<n;i++){var r=a[i],s=r.getElementsByTagName("AdTitle").length?r.getElementsByTagName("AdTitle")[0].textContent.trim():"",o=r.getElementsByTagName("Description").length?r.getElementsByTagName("Description")[0].textContent.trim():"",d=r.getElementsByTagName("ClickThrough").length?r.getElementsByTagName("ClickThrough")[0].textContent.trim():"",l=r.getElementsByTagName("ClickTracking").length?r.getElementsByTagName("ClickTracking")[0].textContent.trim():"",g={id:r.getAttribute("id"),title:s,description:o,impressions:[],clickThrough:d,clickTracking:l,mediaFiles:[],trackingEvents:{},shown:!1},v=r.getElementsByTagName("Impression"),c=r.getElementsByTagName("MediaFile"),m=r.getElementsByTagName("Tracking");e.vastAdTags.push(g);for(var p=0,u=v.length;p<u;p++)g.impressions.push(v[p].textContent.trim());for(var h=0,f=m.length;h<f;h++){var T=m[h],A=T.getAttribute("event");void 0===g.trackingEvents[A]&&(g.trackingEvents[A]=[]),g.trackingEvents[A].push(T.textContent.trim())}for(var k=0,E=c.length;k<E;k++){var y=c[k],x=y.getAttribute("type");if(""!==e.media.canPlayType(x)||/(no|false)/i.test(e.media.canPlayType(x)))if("application/javascript"===y.getAttribute("type")){var P=document.createElement("script"),L=document.getElementsByTagName("script")[0];P.src=y.textContent.trim(),L.parentNode.insertBefore(P,L)}else"application/x-shockwave-flash"!==y.getAttribute("delivery")&&g.mediaFiles.push({id:y.getAttribute("id"),delivery:y.getAttribute("delivery"),type:y.getAttribute("type"),bitrate:y.getAttribute("bitrate"),width:y.getAttribute("width"),height:y.getAttribute("height"),url:y.textContent.trim()})}}e.vastLoaded()}},vpaidParseVpaidData:function(t){var e=this,a=t.getElementsByTagName("AdParameters");if(e.vpaidAdTags=[],e.options.indexPreroll=0,void 0!==a[0]){var i=JSON.parse(a[0].textContent.trim()),n=t.getElementsByTagName("Duration"),r={id:i.ad_id.trim(),title:i.title.trim(),clickThrough:i.page_url,impressions:[],mediaFiles:[],trackingEvents:{},shown:!1};if(void 0!==i.media.tracking.beacon)for(var s=["initialization","start","firstQuartile","midpoint","thirdQuartile","complete"],o=0,d=i.media.tracking.beacon.length;o<d;o++){var l=i.media.tracking.beacon[o];~s.indexOf(l.type)?(void 0===r.trackingEvents[l.type]&&(r.trackingEvents[l.type]=[]),r.trackingEvents[l.type].push(l.beacon_url.trim())):"impression"===l.type&&r.impressions.push(l.beacon_url.trim())}for(var g in i.media.video)if(i.media.video.hasOwnProperty(g)){var v=i.media.video[g],c=v.mime_type.trim();(""!==e.media.canPlayType(c)||/(no|false)/i.test(e.media.canPlayType(c)))&&r.mediaFiles.push({id:v.media_id,format:v.format,type:c,transcoding:v.transcoding,width:v.width,height:v.height,duration:n,url:v.media_url})}e.vastAdTags.push(r),e.vastLoaded()}},vastLoaded:function(){var t=this;t.vastAdTagIsLoaded=!0,t.vastAdTagIsLoading=!1,t.adsDataIsLoading=!1,t.vastStartPreroll()},vastStartPreroll:function(){for(var t=this,e=0;e<t.vastAdTags.length;)void 0!==t.vastAdTags[e].mediaFiles&&t.vastAdTags[e].mediaFiles.length&&(t.options.adsPrerollMediaUrl[e]=t.vastAdTags[e].mediaFiles[0].url),void 0!==t.vastAdTags[e].clickThrough&&(t.options.adsPrerollAdUrl[e]=t.vastAdTags[e].clickThrough),e++;t.adsStartPreroll()}})},{}]},{},[1]);